﻿var demoApp = angular.module('demoApp', []).run(function ($http) {
    $http.defaults.headers.common.Accept = "application/json;odata=verbose";
});

demoApp.controller('demoController', function ($scope, fieldsFactory) {

    init();

    function init() {
        fieldsFactory.getFields().then(function (result) {
            var results = result.data.d.results;

            $scope.fields = [];

            for (var x = 0; x < results.length; x++) {
                var field = initializeField(results[x]);
                $scope.fields.push(field);
            }
        });
    };

    function initializeField(result) {
        var retVal = {};
        retVal.Id = result.Id;
        retVal.FieldDisplayName = result.Title;
        retVal.FieldInternalName = result.InternalName;
        retVal.FieldType = result.FieldType;
        return retVal;
    };
});

demoApp.factory('fieldsFactory', function ($q, $http) {
    var webUrl = _spPageContextInfo.webServerRelativeUrl + "_api/";

    var factory = {};
    //Loads the fields to render on the form
    factory.getFields = function () {
        var restQueryUrl = webUrl + "web/lists/getbytitle('Fields List')/Items";
        return $http.get(restQueryUrl);
    };

    return factory;
});